#define _CRT_SECURE_NO_WARNINGS
#include "epm_handler_common.h"

int ML_CheckCharLenthMessage(EPM_action_message_t msg)
{
	printf("=========================校验字符长度弹出错误框 Start===================\n");
	auto startTime = std::chrono::high_resolution_clock::now();
	int ifail = ITK_ok;
	int  attachments_num = 0;
	tag_t  rootTask = NULLTAG, *attachments = NULLTAG;
	//获取任务对象
	EPM_ask_root_task(msg.task, &rootTask);
	//获取任务目标对象
	EPM_ask_attachments(rootTask, EPM_target_attachment, &attachments_num, &attachments);

	char *argflag = NULL, *argvalue = NULL, *arg = NULL;
	char arg1value[1024] = "", arg2value[1024] = "";
	//获取参数
	int arg_cnt = TC_number_of_arguments(msg.arguments);
	printf("参数个数为：%d\n", arg_cnt);
	if (arg_cnt > 0)
	{
		for (int i = 0; i<arg_cnt; i++)
		{
			//获取下一个参数（从0开始）
			arg = TC_next_argument(msg.arguments);
			//获取参数的名称和值
			ifail = ITK_ask_argument_named_value((const char*)arg, &argflag, &argvalue);
			if (stricmp(argflag, "itemType") == 0)
			{
				if (argvalue != NULL)
				{
					strcpy(arg1value, argvalue);
				}
			}
			else if (stricmp(argflag, "propertyName") == 0)
			{
				if (argvalue != NULL)
				{
					strcpy(arg2value, argvalue);
				}
			}
		}
	}

	char resultString[2048] = "";
	for (int i = 0; i < attachments_num; i++)
	{
		char *itemType = NULL;

		AOM_ask_value_string(attachments[i], "object_type", &itemType);
		printf("type_class : %s,arg1value：%s \r\n", itemType, arg1value);
		//过滤掉非版本的对象
		if ((strcmp(itemType, arg1value) != 0))
		{
			DOFREE(itemType);
			continue;
		}

		//获取属性
		char * propertyValue = NULL;
		AOM_ask_value_string(attachments[i], arg2value, &propertyValue);
		//判断是否超过40位
		int len = gbk_strlen(propertyValue);
		if (len > 40)
		{
			strcat(resultString, "属性");
			strcat(resultString, arg2value);
			strcat(resultString, "的值：");
			strcat(resultString, propertyValue);
			strcat(resultString, "已超过40个字符");
			strcat(resultString, "/n");
		}
		DOFREE(propertyValue);
		DOFREE(itemType);
	}
	DOFREE(attachments);
	if (gbk_strlen(resultString) > 2)
	{
		ifail = 1;
		EMH_store_error_s1(EMH_severity_user_error, EMH_USER_error_base, resultString);
	}

	auto stopTime = std::chrono::high_resolution_clock::now();
	auto duration = std::chrono::duration_cast<std::chrono::microseconds>(stopTime - startTime);
	//std::cout << "ML_CheckCharLenthMessage用时:" << duration.count() / 1000 << std::endl;
	string usetime = "ML_CheckCharLenthMessage用时:";
	usetime.append(std::to_string(duration.count() / 1000));
	WriteLog(true, usetime.c_str());
	printf("=========================校验字符长度弹出错误框 End===================\n");
	return ifail;
}